jsfeat
======

### JavaScript Computer Vision library ###

The project aim is to explore JS/HTML5 possibilities using modern & state-of-art computer vision algorithms.

[Examples and Documentation](http://inspirit.github.com/jsfeat/)

### Features ###

* Custom data structures
* Basic image processing methods (grayscale, derivatives, box-blur, resample, etc.)
 * grayscale ([Demo](http://inspirit.github.com/jsfeat/sample_grayscale.html))
 * box blur ([Demo](http://inspirit.github.com/jsfeat/sample_boxblur.html))
 * gaussian blur ([Demo](http://inspirit.github.com/jsfeat/sample_gaussblur.html))
 * equalize histogram ([Demo](http://inspirit.github.com/jsfeat/sample_equalize_hist.html))
 * canny edges ([Demo](http://inspirit.github.com/jsfeat/sample_canny_edge.html))
 * sobel deriv ([Demo](http://inspirit.github.com/jsfeat/sample_sobel.html))
 * scharr deriv ([Demo](http://inspirit.github.com/jsfeat/sample_scharr.html))
 * find more at Examples and Documentation page
* Linear Algebra module
 * LU (Gaussian elimination) solver
 * Cholesky solver
 * SVD decomposition, solver and pseudo-inverse
 * Eigen Vectors and Values
* Multiview module  ([Demo](http://inspirit.github.com/jsfeat/sample_videostab.html))
 * Affine2D motion kernel
 * Homography2D motion kernel
 * RANSAC motion estimator
 * LMEDS motion estimator
* Matrix Math module for various matrix operation such as traspose, multiply etc.
* Features 2D
 * Fast Corners feature detector ([Demo](http://inspirit.github.com/jsfeat/sample_fast_corners.html))
 * YAPE06 feature detector ([Demo](http://inspirit.github.com/jsfeat/sample_yape06.html))
 * YAPE feature detector ([Demo](http://inspirit.github.com/jsfeat/sample_yape.html))
 * ORB feature descriptor ([Demo](http://inspirit.github.com/jsfeat/sample_orb.html))
* Lucas-Kanade optical flow ([Demo](http://inspirit.github.com/jsfeat/sample_oflow_lk.html) - click to add points)
* HAAR object detector ([Demo](http://inspirit.github.com/jsfeat/sample_haar_face.html))
* BBF object detector ([Demo](http://inspirit.github.com/jsfeat/sample_bbf_face.html))
